//     Copyright 2010 TOMITA Hiroshi <tomykaira@gmail.com>

//     This program is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.

//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.

//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.


var map_x = 15;
var map_y = 30;

var space = "ENTRANCE";

var c = new Array();
var ccodes = new Array();
grad = mono = new Array();

ccodes['mono'] = ["0","1"];
ccodes['grad'] = ["0.0","0.1","0.2","0.3","0.4","0.5","0.6","0.7","0.8","0.9","1.0"];

grad['0.0']='#000';
grad['0.1']='#111';
grad['0.2']='#222';
grad['0.3']='#333';
grad['0.4']='#444';
grad['0.5']='#555';
grad['0.6']='#666';
grad['0.7']='#777';
grad['0.8']='#888';
grad['0.9']='#999';
grad['1.0']='#AAA';

mono['0']='#000';
mono['1']='#FFF';

var pushed = false;
var color = '';
var ccode = '';

$(function(){startup('mono')});

function startup(set) {
    var s = '';
    c = eval(set);
    if( $('#canvas').html() == '' ){
        for (var y = 0; y < map_y; y++) {
            s += '<tr id=r'+y+'>';
            for (var x = 0; x < map_x; x++) {
                s += '<td id=c'+x+'></td>';
            }
            s += '</tr>';
        }
        $('#canvas').html(s);
        $('#canvas td').css('backgroundColor',c[ccodes[set][0]]).text(ccodes[set][0]);

    }
    
    s = '<tr>';
    for (var x = 0; x < ccodes[set].length; x++) {
        s += '<td style="background-color: ' + c[ccodes[set][x]] + ';">'+ccodes[set][x]+'</td>';
    }
    s += '</tr>';
    $('#palette').html(s);

    $('#canvas td').mousedown(function() {
        pushed = true;
        $(this).css('backgroundColor', color)
            .text(ccode);
        $("#x1").val( /\d+/.exec($(this).attr('id')) );
        $("#y1").val( /\d+/.exec($(this).parent("#canvas tr").attr('id')) );
        return false;
    }).mousemove(function() {
        if (pushed) $(this).css('backgroundColor', color)
            .text(ccode);
        return false;
    });
    
    $('body').mouseup(function() {
        pushed = false;
    });

    $('#palette td').click(function() {
        $(this).css('borderColor', 'yellow').siblings().css('borderColor', 'gray');
        color = $(this).css('backgroundColor');
        ccode = $(this).text();
    }).eq(0).click();
}

function load(){
    var s='';
    var point = 0;
    var csv;
    var a = $("#data").val();
    var data = '';

    a.replace("\n","");
    datas = a.replace(/UNIVERSE\.[A-Z]*\..*=\s*1\((.*)\);/,'$1').split(',');

    $.each(datas,function(){
        data = $.trim(this);
        csv = data.split("*");
        for(i=0;i<parseInt(csv[0]);i++){
            $("#canvas #r"+(map_y-1-point%map_y)+">#c"+parseInt(point/map_y))
                .css('backgroundColor',c[csv[1]]).text(csv[1]);
            point ++ ;
        }
    });
    return true;
}

function out(inv){
    var s = 'UNIVERSE.'+space+'.'+$("#title").val().toUpperCase()+' = 1(';
    var prev = '';
    var count = 0;

    if(inv){
        for(i=0;i<map_x;i++){
            for(j=0;j<map_y;j++){
                if( $("#canvas #r"+j+">#c"+(map_x-1-i)).text() == prev)
                    count ++;
                else{
                    if(count != 0)
                        s += String(count) + "*" + prev + ', ';
                    prev = $("#canvas #r"+j+">#c"+(map_x-1-i)).text();
                    count = 1;
                }
            }
        }
    } else {
        for(i=0;i<map_x;i++){
            for(j=0;j<map_y;j++){
                if( $("#canvas #r"+(map_y-1-j)+">#c"+i).text() == prev)
                    count ++;
                else{
                    if(count)
                        s += String(count) + "*" + prev + ', ';
                    prev = $("#canvas #r"+(map_y-1-j)+">#c"+i).text();
                    count = 1;
                }
            }
        }
    }
    
    s += String(count) + "*" + prev + ");\n";// last value is not added.
    $("#data").val(s);
    
    return true;
}

function fill(){
    x1 = Number($("#x1").val());
    x2 = Number($("#x2").val());
    y1 = Number($("#y1").val());
    y2 = Number($("#y2").val());
    
    if(x1 > x2){
        temp = x1;
        x1 = x2;
        x2 = temp;
    }
    if(y1 > y2){
        temp = y1;
        y1 = y2;
        y2 = temp;
    }
    
    for(i=x1;i<x2;i++){
        for(j=y1;j<y2;j++){
            $("#canvas #r"+j+">#c"+i).css('backgroundColor', color)
                .text(ccode);
        }
    }
}
