// artisoc results reader
//     Copyright 2010 TOMITA Hiroshi <tomykaira@gmail.com>

//     This program is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.

//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.

//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <sstream>
#include <cstring>
#include <ctime>
#include <cstdlib>

using namespace std;

vector<string> split(string str, string delim)
{
  vector<string> result;
  int cutAt;
  while( (cutAt = str.find_first_of(delim)) != str.npos )
    {
      if(cutAt > 0)
        {
          result.push_back(str.substr(0, cutAt));
        }
      str = str.substr(cutAt + 1);
    }
  if(str.length() > 0)
    {
      result.push_back(str);
    }
  return result;
}

int main (int argc,char *argv[]){
  char fn[1024],fnp[1024],buf[1024];
  string path,title ;
  if(argc <= 2){
    cout << "Usage : " << endl;
    cout << argv[0] << " [path to model directory] [model name]";
    return 1;
  } else {
    path = string(argv[1]);
    title = string(argv[2]);
  }

  sprintf(fn,"%s.txt",title.c_str());
  ofstream o(fn);
  ifstream ifs ;
  string mode;
  string s;
  vector<string> ss;
  int  death, ti, lines;
  double out, in,td ;

  o << "#\t" << title << "_o\t" << title << "_i" << endl;
  for( int i=1; i<=10; i++){
    lines = 0;
    out = in = 0;
    death = 0;
    sprintf(fn, "%soutput%d.txt",path.c_str(),i);
    ifs.open( fn ) ;
    if (! ifs.is_open()){
      cout << "File open failed.\n\t" << fn << endl;
      return -1;
    }
    cout << "Reading .... "<< fn << endl;
    ifs.getline(buf,1024);
    if (strstr(buf,":") != NULL){
      ss = split(string(buf),":");
      mode = string(ss[1],0,ss[1].size()-1);// the last letter will be \n
    } else {
      ifs.seekg(0,ios::beg);
    }
    while( ifs >> s ){
      ss = split(s,",");
      if( ss.size() < 3) break;
      istringstream(ss[1]) >> td;
      out += td;
      istringstream(ss[2]) >> td;
      in += td;
      lines ++;
    }
    ifs.close();
    o << mode << "\t" << (out/lines) << "\t" << (in/lines) << endl ;
    //results writing
  }

  return 0;
}
