<?php
//     Copyright 2010 TOMITA Hiroshi <tomykaira@gmail.com>

//     This program is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.

//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.

//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.

require_once('zip.lib.php');

ini_set('display_errors', 1);
error_reporting(E_ERROR);

$space = 'ENTRANCE';
$bgname = 'back.gif';

$x = intval($_POST['x']);
$y = intval($_POST['y']);
$DAT = $_POST['dat'];

$modelname = ($_POST['modelname'] || $_POST['modelname'] != '') ?
  $_POST['modelname'] : 'doors';

// replacement rule
$rules = array(
               '{$x}' => $x,
               '{$y}' => $y,
               '{$DAT}' => $DAT,
               '{$xdec}' => $x-1,
               '{$ydec}' => $y-1,
               '{$xy}' => $x * $y,
               );

$mapnames = array ("BLOCK", "IN_HESI", "OUT_HESI");


// new class
// map.txt
$zipfile = new zipfile();
$zipfile -> addFile( $DAT, "map.txt");

// model file
$contents= file_get_contents('template.model');

foreach ($rules as $search => $repl)
  $contents =  str_replace($search, $repl, $contents);

$zipfile -> addFile( $contents, $modelname.".model" );

// gif generator
foreach (explode("\n",$DAT) as $line){
  foreach ($mapnames as $name){
    if( strpos($line,$name)!==FALSE ){
      $orig[$name] = explode(",",preg_replace('/UNIVERSE\.'.$space.'\.'.$name.'\s=\s1\((.*)\);/','$1',$line));
    }
  }
}

foreach($mapnames as $name){
$maps[$name] = array();

$point = 0;
foreach ($orig[$name] as $d){
	list($count,$value) = explode("*",trim($d));
	for ($j=0;$j<$count;$j++){
		$maps[$name][intval($point/$y)][$y-1-$point%$y] = floatval($value) ;
		$point ++ ;
	}
}
}

$img = ImageCreateTrueColor($x,$y);
$black = ImageColorAllocate($img, 0x00, 0x00, 0x00);
$white = ImageColorAllocate($img, 0xFF, 0xFF, 0xFF);

ImageFill($img, 0,0, $black);

for($j=0;$j<$x;$j++){
for($i=0;$i<$y;$i++){
if($maps['BLOCK'][$j][$i] == 1)
	ImageSetPixel($img, $j, $i, $white);
else{
	$p = ImageColorAllocate($img,($maps['IN_HESI'][$j][$i]*250),0,($maps['OUT_HESI'][$j][$i]*250));
	if (!ImageSetPixel($img, $j, $i, $p)){
		echo "Aborted: ImageSetPixel()";
    exit;
  }
	imagecolordeallocate($img,$p);
}	
}
}

// There is need for temporary file saving...
$tempgif = tempnam(sys_get_temp_dir(), "smg");
imagegif($img,$tempgif);
$content = file_get_contents($tempgif);
$zipfile -> addFile($content, $bgname);
unlink($tempgif);

// download sequence
$zip_buffer = $zipfile->file();

header('Content-Type: application/octet-stream');
header("Content-Disposition: attachment; filename=\"".$modelname.".zip\"");
print($zip_buffer) ;
?>
